--------------------------------------------------------------------------------
-- Devkit by Holzchopf
-- v1.1	- 14 sep 2013	- improved controls
--------------------------------------------------------------------------------

-- setup
if holzchopf==nil then holzchopf={} end
holzchopf.devkit={}
holzchopf.devkit.menu=1
holzchopf.devkit.changetime=0
-- particle stuff
holzchopf.devkit.particles={"p_smoke",
	"p_lightpuff",
	"p_fragment",
	"p_blood",
	"p_bigblood",
	"p_muzzle",
	"p_bubble",
	"p_waterray",
	"p_waterhit",
	"p_bodypart",
	"p_ring",
	"p_firefragment",
	"p_explosion",
	"p_dust",
	"p_flare",
	"p_spark",
	"p_bullet",
	"p_dirtfall",
	"p_lightray",
	"p_explosionring",
	"p_scaleflare",
	"p_feather",
	"p_blooddrop",
	"p_meat",
	"p_splatterbeam"}
holzchopf.devkit.particle=1
holzchopf.devkit.sizes={0.1,0.5,1,5,10,50,100}
holzchopf.devkit.size=3
holzchopf.devkit.colours={0,64,128,192,255}
holzchopf.devkit.red=5
holzchopf.devkit.green=5
holzchopf.devkit.blue=5
-- decal stuff
holzchopf.devkit.decals={"gfx_blood25",
	"gfx_blood50",
	"gfx_blood75",
	"gfx_crater25",
	"gfx_crater50",
	"gfx_crater75",
	"gfx_crater100",
	"gfx_crater125",
	"gfx_crater150",
	"gfx_crater175",
	"gfx_crater200",
	"gfx_fire",
	"gfx_flare1",
	"gfx_flare2",
	"gfx_flare3"}
holzchopf.devkit.decal=1
holzchopf.devkit.alphas={0.2,0.4,0.6,0.8,1}
holzchopf.devkit.decalalpha=5
holzchopf.devkit.decalred=1
holzchopf.devkit.decalgreen=1
holzchopf.devkit.decalblue=1
-- painting stuff
holzchopf.devkit.brushes={"rect", "circle"}
holzchopf.devkit.brush=1
holzchopf.devkit.brushmodes={"draw","erase"}
holzchopf.devkit.brushmode=1
holzchopf.devkit.brushsizes={8,16,25,45,80,100}
holzchopf.devkit.brushsize=3
-- terrainexplosion
holzchopf.devkit.explsizes={2,5,10,25,50,100}
holzchopf.devkit.explsize=1
holzchopf.devkit.explmodes={"0: gun impact","1: explosion","2: digging","3: no destruction"}
holzchopf.devkit.explmode=1
-- measurement
holzchopf.devkit.cursor1=nil
holzchopf.devkit.cursor2=nil
-- sounds
holzchopf.devkit.sounds={"sfx_explosion1",
	"sfx_explosion2",
	"sfx_explosion3",
	"sfx_explosion4",
	"sfx_explosion5",
	"sfx_explosion6",
	"sfx_explosion7",
	"sfx_hitwater1",
	"sfx_hitwater2",
	"sfx_hitwater3",
	"sfx_hitwater4",
	"sfx_hitwater5",
	"sfx_splatter1",
	"sfx_splatter2",
	"sfx_splatter3",
	"sfx_splatter4",
	"sfx_splatter5",
	"sfx_ricochet1",
	"sfx_waterstep",
	"sfx_steam",
	"sfx_turn_next",
	"sfx_turn_you",
	"sfx_turn_roundgong"}
holzchopf.devkit.sound=1
holzchopf.devkit.volumes={0.2,0.4,0.6,0.8,1}
holzchopf.devkit.volume=5

-- load resources
holzchopf.devkit.gfx_icn=loadgfx("devkit/icon.png")
setmidhandle(holzchopf.devkit.gfx_icn)
holzchopf.devkit.gfx_info=loadgfx("devkit/info.png")
holzchopf.devkit.gfx_back=loadgfx("devkit/back.png")
holzchopf.devkit.gfx_particles=loadgfx("devkit/particles.png")
holzchopf.devkit.gfx_particle=loadgfx("devkit/particle.png")
holzchopf.devkit.gfx_size=loadgfx("devkit/size.png")
holzchopf.devkit.gfx_red=loadgfx("devkit/red.png")
holzchopf.devkit.gfx_green=loadgfx("devkit/green.png")
holzchopf.devkit.gfx_blue=loadgfx("devkit/blue.png")
holzchopf.devkit.gfx_decals=loadgfx("devkit/decals.png")
holzchopf.devkit.gfx_decal=loadgfx("devkit/decal.png")
holzchopf.devkit.gfx_alpha=loadgfx("devkit/alpha.png")
holzchopf.devkit.gfx_paint=loadgfx("devkit/paint.png")
holzchopf.devkit.gfx_brush=loadgfx("devkit/brush.png")
holzchopf.devkit.gfx_mode=loadgfx("devkit/mode.png")
holzchopf.devkit.gfx_terrainexplosion=loadgfx("devkit/terrainexplosion.png")
holzchopf.devkit.gfx_measurement=loadgfx("devkit/measurement.png")
holzchopf.devkit.gfx_cursor1=loadgfx("devkit/cursor1.png")
holzchopf.devkit.gfx_cursor2=loadgfx("devkit/cursor2.png")
holzchopf.devkit.gfx_distance=loadgfx("devkit/distance.png")
holzchopf.devkit.gfx_angle=loadgfx("devkit/angle.png")
holzchopf.devkit.gfx_remove=loadgfx("devkit/remove.png")
holzchopf.devkit.gfx_sounds=loadgfx("devkit/sounds.png")
holzchopf.devkit.gfx_sound=loadgfx("devkit/sound.png")
holzchopf.devkit.gfx_volume=loadgfx("devkit/volume.png")
holzchopf.devkit.gfx_cursor=loadgfx("devkit/cursor.png")
setmidhandle(holzchopf.devkit.gfx_cursor)
holzchopf.devkit.gfx_endturn=loadgfx("devkit/endturn.png")

--------------------------------------------------------------------------------
-- Devkit
--------------------------------------------------------------------------------
holzchopf.devkit.id=addweapon("holzchopf.devkit","Devkit",holzchopf.devkit.gfx_icn,100)
addweaponinfo("!!! Only for dev-purposes !!! Allows you to do pretty much everything possible.")

function holzchopf.devkit.draw()
	if weapon_mode==1 then return end
	holzchopf.devkit.measurement()
	hudpositioning(pos_invisible)
	-- reset
	if weapon_shots==0 then
		holzchopf.devkit.changetime=0
		holzchopf.devkit.menu=1
		holzchopf.devkit.nextmenu=1
		holzchopf.devkit.prevmenu=1
		holzchopf.devkit.key_attack=0
		holzchopf.devkit.key_up=0
		holzchopf.devkit.key_down=0
		weapon_shots=1
		playercontrol(0)
	end
	holzchopf.devkit.key_up=keyhit(key_up)
	holzchopf.devkit.key_dn=keyhit(key_down)
	holzchopf.devkit.key_lf=keyhit(key_left)
	holzchopf.devkit.key_rt=keyhit(key_right)
	holzchopf.devkit.key_att=keyhit(key_attack)
	-- increase time from time to time
	if getframe()>=holzchopf.devkit.changetime then
		holzchopf.devkit.changetime=getframe()+50
		changeturntime(1)
	end
	holzchopf.devkit.y=40
	local menu=holzchopf.devkit.menu
	-- main menu
	if menu<=10 then
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_info,1,1)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_particles,2,21)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_decals,3,31)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_paint,4,41)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_terrainexplosion,5,51)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_sounds,6,61)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_measurement,7,71)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_endturn,8,81)
		holzchopf.devkit.navigate(1,8)
		if     menu==1 then hudinfo("Use [Up] / [Down] and [Attack] to navigate")
		elseif menu==2 then hudinfo("[Mouse] to create particles, [Attack] to change")
		elseif menu==3 then hudinfo("[Mouse] to draw decals, [Attack] to change")
		elseif menu==4 then hudinfo("[Mouse] to paint terrain, [Attack] to change")
		elseif menu==5 then hudinfo("[Mouse] for terrainexplosion, [Attack] to change")
		elseif menu==6 then hudinfo("[Mouse] to play sound, [Attack] to change")
		elseif menu==7 then hudinfo("[Attack] to open measurement menu")
		elseif menu==8 then hudinfo("[Attack] to end end turn")
		end
	-- particle menu
	elseif menu>20 and menu<30 then
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_particle,21)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_size,22)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_red,23)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_green,24)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_blue,25)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_back,26,2)
		holzchopf.devkit.navigate(21,26)
		if     menu==21 then
			holzchopf.devkit.particle=holzchopf.devkit.change(holzchopf.devkit.particle,1,#holzchopf.devkit.particles)
			hudinfo("Particle: "..holzchopf.devkit.particles[holzchopf.devkit.particle].." (Change with [Left] / [Right])")
		elseif menu==22 then
			holzchopf.devkit.size=holzchopf.devkit.change(holzchopf.devkit.size,1,#holzchopf.devkit.sizes)
			hudinfo("Size: "..holzchopf.devkit.sizes[holzchopf.devkit.size].." (Change with [Left] / [Right])")
		elseif menu==23 then
			holzchopf.devkit.red=holzchopf.devkit.change(holzchopf.devkit.red,1,#holzchopf.devkit.colours)
			hudinfo("Red: "..holzchopf.devkit.colours[holzchopf.devkit.red].." (Change with [Left] / [Right])")
		elseif menu==24 then
			holzchopf.devkit.green=holzchopf.devkit.change(holzchopf.devkit.green,1,#holzchopf.devkit.colours)
			hudinfo("Green: "..holzchopf.devkit.colours[holzchopf.devkit.green].." (Change with [Left] / [Right])")
		elseif menu==25 then
			holzchopf.devkit.blue=holzchopf.devkit.change(holzchopf.devkit.blue,1,#holzchopf.devkit.colours)
			hudinfo("Blue: "..holzchopf.devkit.colours[holzchopf.devkit.blue].." (Change with [Left] / [Right])")
		elseif menu==26 then
			hudinfo("Back to main menu")
		end
	-- decal menu
	elseif menu>30 and menu<40 then
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_decal,31)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_alpha,32)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_red,33)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_green,34)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_blue,35)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_back,36,3)
		holzchopf.devkit.navigate(31,36)
		if     menu==31 then
			holzchopf.devkit.decal=holzchopf.devkit.change(holzchopf.devkit.decal,1,#holzchopf.devkit.decals)
			hudinfo("Decal: "..holzchopf.devkit.decals[holzchopf.devkit.decal].." (Change with [Left] / [Right])")
		elseif menu==32 then
			holzchopf.devkit.decalalpha=holzchopf.devkit.change(holzchopf.devkit.decalalpha,1,#holzchopf.devkit.alphas)
			hudinfo("Alpha: "..holzchopf.devkit.alphas[holzchopf.devkit.decalalpha].." (Change with [Left] / [Right])")
		elseif menu==33 then
			holzchopf.devkit.decalred=holzchopf.devkit.change(holzchopf.devkit.decalred,1,#holzchopf.devkit.colours)
			hudinfo("Red: "..holzchopf.devkit.colours[holzchopf.devkit.decalred].." (Change with [Left] / [Right])")
		elseif menu==34 then
			holzchopf.devkit.decalgreen=holzchopf.devkit.change(holzchopf.devkit.decalgreen,1,#holzchopf.devkit.colours)
			hudinfo("Green: "..holzchopf.devkit.colours[holzchopf.devkit.decalgreen].." (Change with [Left] / [Right])")
		elseif menu==35 then
			holzchopf.devkit.decalblue=holzchopf.devkit.change(holzchopf.devkit.decalblue,1,#holzchopf.devkit.colours)
			hudinfo("Blue: "..holzchopf.devkit.colours[holzchopf.devkit.decalblue].." (Change with [Left] / [Right])")
		elseif menu==36 then
			hudinfo("Back to main menu")
		end
	-- paint menu
	elseif menu>40 and menu<50 then
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_brush,41)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_mode,42)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_size,43)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_back,44,4)
		holzchopf.devkit.navigate(41,44)
		if     menu==41 then
			holzchopf.devkit.brush=holzchopf.devkit.change(holzchopf.devkit.brush,1,2)
			hudinfo("Brush: "..holzchopf.devkit.brushes[holzchopf.devkit.brush].." (Change with [Left] / [Right])")
		elseif menu==42 then
			holzchopf.devkit.brushmode=holzchopf.devkit.change(holzchopf.devkit.brushmode,1,2)
			hudinfo("Mode: "..holzchopf.devkit.brushmodes[holzchopf.devkit.brushmode].." (Change with [Left] / [Right])")
		elseif menu==43 then
			holzchopf.devkit.brushsize=holzchopf.devkit.change(holzchopf.devkit.brushsize,1,#holzchopf.devkit.brushsizes)
			hudinfo("Size: "..holzchopf.devkit.brushsizes[holzchopf.devkit.brushsize].." (Change with [Left] / [Right])")
		elseif menu==44 then
			hudinfo("Back to main menu")
		end
	-- terrainexplosion menu
	elseif menu>50 and menu<60 then
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_size,51)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_mode,52)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_back,53,5)
		holzchopf.devkit.navigate(51,53)
		if     menu==51 then
			holzchopf.devkit.explsize=holzchopf.devkit.change(holzchopf.devkit.explsize,1,#holzchopf.devkit.explsizes)
			hudinfo("Radius: "..holzchopf.devkit.explsizes[holzchopf.devkit.explsize].." (Change with [Left] / [Right])")
		elseif menu==52 then
			holzchopf.devkit.explmode=holzchopf.devkit.change(holzchopf.devkit.explmode,1,#holzchopf.devkit.explmodes)
			hudinfo("Effect: "..holzchopf.devkit.explmodes[holzchopf.devkit.explmode].." (Change with [Left] / [Right])")
		elseif menu==53 then
			hudinfo("Back to main menu")
		end
	-- sounds menu
	elseif menu>60 and menu<70 then
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_sound,61)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_volume,62)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_back,63,6)
		holzchopf.devkit.navigate(61,63)
		if     menu==61 then
			holzchopf.devkit.sound=holzchopf.devkit.change(holzchopf.devkit.sound,1,#holzchopf.devkit.sounds)
			hudinfo("Sound: "..holzchopf.devkit.sounds[holzchopf.devkit.sound].." (Change with [Left] / [Right])")
		elseif menu==62 then
			holzchopf.devkit.volume=holzchopf.devkit.change(holzchopf.devkit.volume,1,#holzchopf.devkit.volumes)
			hudinfo("Volume: "..holzchopf.devkit.volumes[holzchopf.devkit.volume].." (Change with [Left] / [Right])")
		elseif menu==63 then
			hudinfo("Back to main menu")
		end
	-- measurement menu
	elseif menu>70 and menu<80 then
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_cursor1,71)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_cursor2,72)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_distance,73)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_angle,74)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_remove,75,751)
		holzchopf.devkit.drawmenu(holzchopf.devkit.gfx_back,76,7)
		holzchopf.devkit.navigate(71,76)
		local dist=" - "
		local distx=" - "
		local disty=" - "
		local angle=" - "
		if holzchopf.devkit.measx~=nil then distx=holzchopf.devkit.measx end
		if holzchopf.devkit.measy~=nil then disty=holzchopf.devkit.measy end
		if holzchopf.devkit.angle~=nil then
			angle=math.deg(holzchopf.devkit.angle)
			angle=math.floor(angle*10+0.5)/10
		end
		if holzchopf.devkit.measx~=nil and holzchopf.devkit.measy~=nil then
			dist=math.sqrt(distx*distx+disty*disty)
		end
		if     menu==71 then hudinfo("[Mouse] to place cursor 1")
		elseif menu==72 then hudinfo("[Mouse] to place cursor 2")
		elseif menu==73 then hudinfo("Distance: d="..dist.." (x="..distx.." , y="..disty..")")
		elseif menu==74 then hudinfo("Angle: a="..angle.."deg")
		elseif menu==75 then hudinfo("[Attack] to remove cursors")
		elseif menu==76 then hudinfo("Back to main menu")
		end
	-- remove cursors
	elseif menu==751 then
		holzchopf.devkit.cursor1=nil
		holzchopf.devkit.cursor2=nil
		holzchopf.devkit.measx=nil
		holzchopf.devkit.measy=nil
		holzchopf.devkit.angle=nil
		holzchopf.devkit.menu=65
	-- end turn
	elseif menu==81 then
		weapon_mode=1
		endturn()
	end
	-- change menu
	if holzchopf.devkit.key_att==1 then
		holzchopf.devkit.menu=holzchopf.devkit.nextmenu
	end
end

function holzchopf.devkit.drawmenu(image,index,mnext)
	local mmin=math.floor(index/10)*10+1
	local mmax=math.floor(index/10)*10+10
	-- visible
	if holzchopf.devkit.menu>=mmin and holzchopf.devkit.menu<=mmax then
		setblend(blend_alpha)
		setcolor(128,128,128)
		-- highlight
		if index==holzchopf.devkit.menu then
			setcolor(255,0,0)
			-- activated
			if holzchopf.devkit.key_att==1 then
				holzchopf.devkit.nextmenu=mnext
				if mnext==nil then
					holzchopf.devkit.key_att=0
				end
			end
		end
		drawhud(image,40,holzchopf.devkit.y)
		holzchopf.devkit.y=holzchopf.devkit.y+40
	end
end

function holzchopf.devkit.navigate(imin,imax)
	-- prev
	if holzchopf.devkit.key_up==1 then
		holzchopf.devkit.menu=holzchopf.devkit.menu-1
		if holzchopf.devkit.menu<imin then
			holzchopf.devkit.menu=imax
		end
	end
	-- next
	if holzchopf.devkit.key_dn==1 then
		holzchopf.devkit.menu=holzchopf.devkit.menu+1
		if holzchopf.devkit.menu>imax then
			holzchopf.devkit.menu=imin
		end
	end
end

function holzchopf.devkit.change(value,vmin,vmax)
	-- prev
	if holzchopf.devkit.key_rt==1 then
		value=value+1
		if value>vmax then
			value=vmin
		end
	end
	-- next
	if holzchopf.devkit.key_lf==1 then
		value=value-1
		if value<vmin then
			value=vmax
		end
	end
	return value
end

function holzchopf.devkit.attack(attack)
	if weapon_position==1 then
		weapon_position=0
		-- particle
		if holzchopf.devkit.menu==2 or
		  (holzchopf.devkit.menu>20 and holzchopf.devkit.menu<30) then
			local p=holzchopf.devkit.particles[holzchopf.devkit.particle]
			local s=holzchopf.devkit.sizes[holzchopf.devkit.size]
			local r=holzchopf.devkit.colours[holzchopf.devkit.red]
			local g=holzchopf.devkit.colours[holzchopf.devkit.green]
			local b=holzchopf.devkit.colours[holzchopf.devkit.blue]
			particle(_G[p],weapon_x,weapon_y)
			particlesize(s,s)
			particlecolor(r,g,b)
			--particlespeed(1,1)
		-- decal
		elseif holzchopf.devkit.menu==3 or
		  (holzchopf.devkit.menu>30 and holzchopf.devkit.menu<40) then
			local d=holzchopf.devkit.decals[holzchopf.devkit.decal]
			local a=holzchopf.devkit.alphas[holzchopf.devkit.decalalpha]
			local r=holzchopf.devkit.colours[holzchopf.devkit.decalred]
			local g=holzchopf.devkit.colours[holzchopf.devkit.decalgreen]
			local b=holzchopf.devkit.colours[holzchopf.devkit.decalblue]
			terrainalphaimage(_G[d],weapon_x,weapon_y,a,r,g,b)
		-- paint
		elseif holzchopf.devkit.menu==4 or
		  (holzchopf.devkit.menu>40 and holzchopf.devkit.menu<50) then
			local col=0xff888888
			if holzchopf.devkit.brushmode==2 then
				col=0x00000000
			end
			local s=holzchopf.devkit.brushsizes[holzchopf.devkit.brushsize]
			if holzchopf.devkit.brush==1 then
				terrainrect(weapon_x-s*0.5,weapon_y-s*0.5,s,s,col)
			else
				terraincircle(weapon_x,weapon_y,s,col)
			end
		-- terrainexplosion
		elseif holzchopf.devkit.menu==5 or
		  (holzchopf.devkit.menu>50 and holzchopf.devkit.menu<60) then
			local s=holzchopf.devkit.explsizes[holzchopf.devkit.explsize]
			local m=holzchopf.devkit.explmode-1
			terrainexplosion(weapon_x,weapon_y,s,m)
		-- sounds
		elseif holzchopf.devkit.menu==6 or
		  (holzchopf.devkit.menu>=60 and holzchopf.devkit.menu<70) then
			local s=holzchopf.devkit.sounds[holzchopf.devkit.sound]
			local v=holzchopf.devkit.volumes[holzchopf.devkit.volume]
			playsound(_G[s],-1,v)
		-- measurement
		elseif holzchopf.devkit.menu==71 then
			holzchopf.devkit.cursor1={}
			holzchopf.devkit.cursor1.x=weapon_x
			holzchopf.devkit.cursor1.y=weapon_y
			holzchopf.devkit.measure()
			holzchopf.devkit.menu=72
		elseif holzchopf.devkit.menu>=72 and holzchopf.devkit.menu<80 then
			holzchopf.devkit.cursor2={}
			holzchopf.devkit.cursor2.x=weapon_x
			holzchopf.devkit.cursor2.y=weapon_y
			holzchopf.devkit.measure()
			if holzchopf.devkit.menu==72 then holzchopf.devkit.menu=73 end
		end
	end
end

function holzchopf.devkit.measurement()
	if holzchopf.devkit.cursor1~=nil then
		setcolor(255,0,0)
		setblend(blend_alpha)
		drawimage(holzchopf.devkit.gfx_cursor, holzchopf.devkit.cursor1.x,holzchopf.devkit.cursor1.y)
	end
	if holzchopf.devkit.cursor2~=nil then
		setcolor(0,255,0)
		setblend(blend_alpha)
		drawimage(holzchopf.devkit.gfx_cursor, holzchopf.devkit.cursor2.x,holzchopf.devkit.cursor2.y)
	end
end

function holzchopf.devkit.measure()
	if holzchopf.devkit.cursor1~=nil and holzchopf.devkit.cursor2~=nil then
		local dx=holzchopf.devkit.cursor2.x-holzchopf.devkit.cursor1.x
		local dy=holzchopf.devkit.cursor2.y-holzchopf.devkit.cursor1.y
		holzchopf.devkit.measx=dx
		holzchopf.devkit.measy=dy
		holzchopf.devkit.angle=math.atan2(dx,-dy)
	end
end